// AcqDlg.h : header file
//////////////////////////////////////////
// CAcqDlg dialog
class CAcqDlg : public CDialog
{
// Construction
public:
	CAcqDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CAcqDlg)
	enum { IDD = IDD_ACQ };
	CProgressCtrl	m_progress;
	CButton	m_btnCancel;
	CButton	m_btnDemarrer;
	CComboBox	m_comboCourbe;
	int		m_radioTypeDetect;
	float	m_fAngle;
	int		m_iNbPtsMes;
	CString	m_s2;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAcqDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	class CBkDoc *m_pDoc;
	class CBkApp *m_pApp;
	class CEurosmartDX *m_pEuro;
	class CC832DX *m_pC832;
	class CLabmaster *m_pLab;
	BOOL m_OK,m_OKCartePI;
	short m_iN,m_iNb,m_iCourbe;
	float m_fAngleCourant,m_fUP;

	void Stop();


	// Generated message map functions
	//{{AFX_MSG(CAcqDlg)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual void OnCancel();
	afx_msg void OnDemarrer();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
