// ConRsDlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "ConRsDlg.h"
#include "BkView.h"
#include "BkDoc.h"
#include <sys/timeb.h>
#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CConRsDlg dialog
CConRsDlg::CConRsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConRsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConRsDlg)
	m_sTexte1 = _T("");
	m_sTexte2 = _T("");
	//}}AFX_DATA_INIT
	Create(IDD_CONNEXION,pParent);
}
void CConRsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConRsDlg)
	DDX_Text(pDX, IDC_STATIC1, m_sTexte1);
	DDX_Text(pDX, IDC_STATIC2, m_sTexte2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CConRsDlg, CDialog)
	//{{AFX_MSG_MAP(CConRsDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CConRsDlg message handlers
void CConRsDlg::PostNcDestroy()
{
	delete this;
}
//________________________________________
BOOL CConRsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	setlocale(LC_TIME,"French");
	m_pApp=(CBkApp*)AfxGetApp();

	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;


	m_sTexte2.Format("");
	m_sTexte1="";
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CConRsDlg::Fermer(void)
{
	KillTimer(99);
	CloseHandle(m_hCom);
	CDialog::OnCancel();
}
//________________________________________
void CConRsDlg::OnTimer(UINT nIDEvent) 
{
	CString s,s1;
	short i,j,k;
	BOOL ok=FALSE;

	if (m_OKBusy==FALSE)
	{
		m_OKBusy=TRUE;
		//Attente sur port srie
		ok=ReadCom();
		m_t2=CTime::GetCurrentTime();
		CTimeSpan t=m_t2-m_t1;
		s=t.Format("%H:%M:%S");
		if (m_iType==0)
			m_sTexte2.Format("Connect  COM%d:1200,8,'N',1 depuis %s\n(L) Le buffer contient %d caractre(s).",m_radioCom+1,s,m_pBuf->GetLength());
		else
			m_sTexte2.Format("Connect  COM%d:2400,8,'N',1 depuis %s\n(U) Le buffer contient %d caractre(s).",m_radioCom+1,s,m_pBuf->GetLength());
		UpdateData(FALSE);	
		if (m_pBuf->GetLength()>1000)
		{
			s=m_pBuf->Right(20),
			*m_pBuf=s;
			m_sTexte2.Format("Initialisation buffer ...");
			UpdateData(FALSE);
			Sleep(200); 
		}
		if (ok)
		{
			j=0;k=0;
			//On ne garde que les 6 dernires lignes de m_sTexte1
			for (i=0;i<m_sTexte1.GetLength()-1;i++)
			{
				if (m_sTexte1.GetAt(i)=='\r' || m_sTexte1.GetAt(i)=='\n')
				{
					if (j<5) k=i;
					j++;
				}
			}
			if (j>=6)
			{
				s="... "+m_sTexte1.Right(k-3);
				m_sTexte1=s;
			}
		}
		m_OKBusy=FALSE;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
HANDLE CConRsDlg::Connexion_Labmaster(int radioCom,CString *buffer) 
{
	DCB dcb;
	BOOL ok;

	m_pBuf=buffer;
	m_radioCom=radioCom;
	m_iType=0;
	switch (m_radioCom)
	{
		case 0://COM1
			m_hCom=CreateFile("COM1",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
		break;
		case 1://COM2
			m_hCom=CreateFile("COM2",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
		break;
	}
	if (m_hCom==INVALID_HANDLE_VALUE)
	{
		m_sTexte2.Format("Erreur de connexion au port COM%d !",m_radioCom+1);
		UpdateData(FALSE);	
	}
	else
	{
		COMMTIMEOUTS ctmo;
		ok=GetCommTimeouts(m_hCom,&ctmo);
		if (ok)
		{
			ctmo.ReadIntervalTimeout=MAXDWORD;
			ctmo.ReadTotalTimeoutMultiplier=0;
			ctmo.ReadTotalTimeoutConstant=0;
			ctmo.WriteTotalTimeoutConstant=0;
			ctmo.WriteTotalTimeoutMultiplier=0;
			SetCommTimeouts(m_hCom,&ctmo);
		}
		GetCommState(m_hCom,&dcb);
		//Paramtres du port srie pour Labmaster
		//1200,8,'N',1
		CString s="12,n,8,1,x";
		ok=BuildCommDCB(s,&dcb);
		if (!ok) AfxMessageBox("Erreur fonction BuildCommDCB");
		SetCommState(m_hCom,&dcb);

		m_t1=CTime::GetCurrentTime();   
		m_OKBusy=FALSE;SetTimer(99,1,NULL);
	}
	return m_hCom;
}
//________________________________________
HANDLE CConRsDlg::Connexion_Ultima(int radioCom,CString *buffer) 
{
	DCB dcb;
	BOOL ok;

	m_pBuf=buffer;
	m_radioCom=radioCom;
	m_iType=1;
	switch (m_radioCom)
	{
		case 0://COM1
			m_hCom=CreateFile("COM1",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
		break;
		case 1://COM2
			m_hCom=CreateFile("COM2",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
		break;
	}
	if (m_hCom==INVALID_HANDLE_VALUE)
	{
		m_sTexte2.Format("Erreur de connexion au port COM%d !",m_radioCom+1);
		UpdateData(FALSE);	
	}
	else
	{
		COMMTIMEOUTS ctmo;
		ok=GetCommTimeouts(m_hCom,&ctmo);
		if (ok)
		{
			ctmo.ReadIntervalTimeout=MAXDWORD;
			ctmo.ReadTotalTimeoutMultiplier=0;
			ctmo.ReadTotalTimeoutConstant=0;
			ctmo.WriteTotalTimeoutConstant=0;
			ctmo.WriteTotalTimeoutMultiplier=0;
			SetCommTimeouts(m_hCom,&ctmo);
		}
		GetCommState(m_hCom,&dcb);
		//Paramtres du port srie pour Ultima
		//2400,8,'N',1, XON/XOFF
		CString s="24,n,8,1,x";
		ok=BuildCommDCB(s,&dcb);
		if (!ok) AfxMessageBox("Erreur fonction BuildCommDCB");
		SetCommState(m_hCom,&dcb);
		m_t1=CTime::GetCurrentTime();   
		m_OKBusy=FALSE;SetTimer(99,1,NULL);
		m_t1=CTime::GetCurrentTime();   
		m_OKBusy=FALSE;SetTimer(99,1,NULL);
	}
	return m_hCom;
}
//________________________________________
BOOL CConRsDlg::ReadCom(void)
{
	//Les caractres retourns sont dans le buffer m_sBuf
	BOOL ok;
	DWORD i,j;
	char c[17];

	ok=ReadFile(m_hCom,c,16,&j,NULL);
	i=0;
	if (ok && j!=0)
	for (i=0;i<j;i++)
	{
		//Ultima envoie LF, Labmaster CR...
		if (m_pApp->m_radioTypeLab==0)
		{
			//Labmaster
			if (c[i]!='\n')	m_sTexte1=m_sTexte1+c[i];
		}
		else
		{
			//Ultima
			m_sTexte1=m_sTexte1+c[i];
		}
		//Affectation au buffer
		*m_pBuf=*m_pBuf+c[i];
	}
	if (i>0) return TRUE; else return FALSE;
}
