// MainFrm.h : interface of the CMainFrame class
//
//////////////////////////////////////////
#include "Excel8.h"
class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
protected:
	class CBkApp* m_pApp;
	class _Application *m_pAppli;

// Operations
public:
	void EcritureExcel(void);
	void GrapheExcel(_Worksheet sheet,_Chart chart,CString plage1,CString plage2,CString titre,CString nom,CString abs,CString FormatX,CString FormatY);
	float atan3(float n,float d);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnUpdatePage(CCmdUI *pCmdUI);
	afx_msg void OnUpdateExcel(CCmdUI* pCmdUI);
	afx_msg void OnExcel();
	afx_msg void OnUpdateRegression(CCmdUI* pCmdUI);
	afx_msg void OnRegression();
	afx_msg void OnDepManu();
	afx_msg void OnUpdateDepManu(CCmdUI* pCmdUI);
	afx_msg void OnLabmaster();
	afx_msg void OnUpdateCarteAn(CCmdUI* pCmdUI);
	afx_msg void OnCarteAn();
	afx_msg void OnOperation();
	afx_msg void OnUpdateOperation(CCmdUI* pCmdUI);
	afx_msg void OnAcqDiaRay();
	afx_msg void OnGraphesATracer();
	afx_msg void OnCopiercoller();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//////////////////////////////////////////
