// ParaCoDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "ParaCoDlg.h"
#include "BkDoc.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CParaCoDlg dialog
CParaCoDlg::CParaCoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CParaCoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CParaCoDlg)
	m_radioCourbe = -1;
	m_radioOpe = -1;
	m_fCte = 0.0f;
	//}}AFX_DATA_INIT
}
void CParaCoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParaCoDlg)
	DDX_Radio(pDX, IDC_COURBE1, m_radioCourbe);
	DDX_Radio(pDX, IDC_RADIO2, m_radioOpe);
	DDX_Text(pDX, IDC_CTE, m_fCte);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CParaCoDlg, CDialog)
	//{{AFX_MSG_MAP(CParaCoDlg)
	ON_BN_CLICKED(IDAPPLIQUER, OnAppliquer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CParaCoDlg message handlers
void CParaCoDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
BOOL CParaCoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_fCte=m_pDoc->m_fCte;
	m_radioCourbe=m_pDoc->m_radioCourbe;
	m_radioOpe=m_pDoc->m_radioOpe;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CParaCoDlg::OnCancel() 
{
	CDialog::OnCancel();
}
//________________________________________
void CParaCoDlg::OnAppliquer() 
{
	//Appliquer l'opration sans fermer la bote de dialogue
	short
		abs,ord,
		i;
	UpdateData(TRUE);

	abs=2*m_radioCourbe;
	ord=abs+1;

	if (fabs(m_fCte)<1e-4)
	{
		m_fCte=1;
		UpdateData(TRUE);
	}
	else
	{
		switch (m_radioOpe)
		{
			case 0://Addition Cte aux absisses
				for (i=0;i<m_pDoc->m_iNbMax;i++)
				{
					if (m_pDoc->m_fT[i][abs]!=1e10) m_pDoc->m_fT[i][abs]=m_pDoc->m_fT[i][abs]+m_fCte;
				}
			break;
			case 1://Addition Cte aux ordonnes
				for (i=0;i<m_pDoc->m_iNbMax;i++)
				{
					if (m_pDoc->m_fT[i][ord]!=1e10) m_pDoc->m_fT[i][ord]=m_pDoc->m_fT[i][ord]+m_fCte;
				}
			break;
			case 2://Multiplication absisses par Cte
				for (i=0;i<m_pDoc->m_iNbMax;i++)
				{
					if (m_pDoc->m_fT[i][abs]!=1e10) m_pDoc->m_fT[i][abs]=m_pDoc->m_fT[i][abs]*m_fCte;
				}
			break;
			case 3://Multiplication ordonnes par Cte
				for (i=0;i<m_pDoc->m_iNbMax;i++)
				{
					if (m_pDoc->m_fT[i][ord]!=1e10) m_pDoc->m_fT[i][ord]=m_pDoc->m_fT[i][ord]*m_fCte;
				}
			break;
		}
		m_pDoc->UpdateAllViews(NULL);
	}
}
