// CopieDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "CopieDlg.h"
#include "BkDoc.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CCopieDlg dialog
CCopieDlg::CCopieDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCopieDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCopieDlg)
	m_radioDest = -1;
	m_radioSource = -1;
	//}}AFX_DATA_INIT
}
void CCopieDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCopieDlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDC_SOURCE, m_comboSource);
	DDX_Control(pDX, IDC_DEST, m_comboDest);
	DDX_Radio(pDX, IDC_DEST1, m_radioDest);
	DDX_Radio(pDX, IDC_SOURCE1, m_radioSource);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CCopieDlg, CDialog)
	//{{AFX_MSG_MAP(CCopieDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CCopieDlg message handlers
BOOL CCopieDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString s;
	short i,j;
	m_pApp=((CBkApp*)AfxGetApp());
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_ps=(CBkDoc*)pChild->GetActiveDocument(); else m_ps=NULL;
	m_pApp->GetDocument(m_pDoc);
	m_pd=NULL;

	j=0;
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboDest.AddString(s);
			m_comboSource.AddString(s);
			j++;
		}
	}
	if (j<m_pApp->m_iNbMax)
	{
		s="NOUVELLE";
		m_comboDest.AddString(s);
	}
	m_comboDest.GetLBText(m_comboDest.GetCount()-1,s);
	m_comboDest.SetWindowText(s);	
	m_comboSource.GetLBText(m_comboSource.GetCount()-1,s);
	m_comboSource.SetWindowText(s);
	m_radioSource=0;
	m_radioDest=0;
	UpdateData(FALSE);
	SetTimer(53,200,NULL);
	return TRUE;
}
//________________________________________
void CCopieDlg::OnCancel() 
{
	KillTimer(53);	
	CDialog::OnCancel();
}
//________________________________________
void CCopieDlg::OnOK() 
{
	KillTimer(53);
	//UpdateData(TRUE);	
	if (m_pd==NULL) m_pd=m_pApp->CreerNouvelleFenetre(m_ps->m_iL,m_ps->m_iH);
	short i,k,n;
	for (i=0;i<m_ps->m_iNbMax;i++)
	{
		m_pd->m_fT[i][m_radioDest*2]=m_ps->m_fT[i][m_radioSource*2];
		m_pd->m_fT[i][m_radioDest*2+1]=m_ps->m_fT[i][m_radioSource*2+1];
	}
	m_pd->m_iNb=m_ps->m_iNb;
	n=(short)pow(2,m_radioDest);
	if ((m_pd->m_iAcq&n) != n) m_pd->m_iAcq=m_pd->m_iAcq+n;

	k=abs(m_pd->m_iTypeGr);
	if ((k&n) != n) k=k+n;
	m_pd->m_iTypeGr=k;//Cartsien
	m_pd->m_sUnite=m_ps->m_sUnite;

	m_pd->PositionnerFenetre(0,0);	
	CDialog::OnOK();
}
//________________________________________
void CCopieDlg::OnTimer(UINT nIDEvent) 
{
	UpdateData(TRUE);
  BOOL ok=FALSE;	
	if (m_comboSource.GetCurSel()<0)
		m_ps=m_pDoc[m_comboSource.GetCount()-1];
	else
		m_ps=m_pDoc[m_comboSource.GetCurSel()];

	if (m_comboDest.GetCurSel()<0)
		m_pd=m_pDoc[m_comboDest.GetCount()-1];
	else
		m_pd=m_pDoc[m_comboDest.GetCurSel()];
	
	short i;
	if (m_ps!=NULL)
	{
		i=abs(m_ps->m_iTypeGr);
		if ((m_ps->m_iAcq&1)!=1)
		{ 
			GetDlgItem(IDC_SOURCE1)->EnableWindow(FALSE);
			if (m_radioSource==0) m_radioSource=1;
		}
		else
		{
			GetDlgItem(IDC_SOURCE1)->EnableWindow(TRUE);
			ok=TRUE;
		}
		if ((m_ps->m_iAcq&2)!=2)
		{ 
			GetDlgItem(IDC_SOURCE2)->EnableWindow(FALSE);
			if (m_radioSource==1) m_radioSource=2;
		}
		else
		{
			GetDlgItem(IDC_SOURCE2)->EnableWindow(TRUE);
			ok=TRUE;
		}
		if ((m_ps->m_iAcq&4)!=4)
		{ 
			GetDlgItem(IDC_SOURCE3)->EnableWindow(FALSE);
			if (m_radioSource==2) m_radioSource=3;
		}
		else
		{
			GetDlgItem(IDC_SOURCE3)->EnableWindow(TRUE);
			ok=TRUE;
		}
		if ((m_ps->m_iAcq&8)!=8)
		{ 
			GetDlgItem(IDC_SOURCE4)->EnableWindow(FALSE);
			if (m_radioSource==3) m_radioSource=0;
		}
		else
		{
			GetDlgItem(IDC_SOURCE4)->EnableWindow(TRUE);
			ok=TRUE;
		}
	}
	if (m_pd==m_ps && m_radioSource==m_radioDest) ok=FALSE; 
	m_btnOK.EnableWindow(ok);
	
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
