// OpeCoDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Bk.h"
#include "OpeCoDlg.h"
#include "BkDoc.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// COpeCoDlg dialog
COpeCoDlg::COpeCoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COpeCoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COpeCoDlg)
	m_fOffset = 0.0f;
	m_sIntitule = _T("");
	m_fDecAng = 0.0f;
	m_OKNorme = FALSE;
	m_OKIntitule = FALSE;
	m_OKInverser = FALSE;
	m_OKDecaler = FALSE;
	m_OKAjouterOffset = FALSE;
	//}}AFX_DATA_INIT
}
void COpeCoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpeCoDlg)
	DDX_Control(pDX, IDC_COMBO_COURBE, m_comboCourbe);
	DDX_Text(pDX, IDC_OFFSET, m_fOffset);
	DDX_Text(pDX, IDC_INTITULE, m_sIntitule);
	DDX_Text(pDX, IDC_DEC_ANG, m_fDecAng);
	DDX_Check(pDX, IDC_NORME, m_OKNorme);
	DDX_Check(pDX, IDC_INTITUL, m_OKIntitule);
	DDX_Check(pDX, IDC_INVERSER, m_OKInverser);
	DDX_Check(pDX, IDC_DECALER, m_OKDecaler);
	DDX_Check(pDX, IDC_AJOUTEROFFSET, m_OKAjouterOffset);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(COpeCoDlg, CDialog)
	//{{AFX_MSG_MAP(COpeCoDlg)
	ON_BN_CLICKED(IDAPPLI, OnAppli)
	ON_CBN_SELCHANGE(IDC_COMBO_COURBE, OnSelchangeComboCourbe)
	ON_BN_CLICKED(IDC_INTITUL, OnIntitul)
	ON_BN_CLICKED(IDC_DECALER, OnDecaler)
	ON_BN_CLICKED(IDC_AJOUTEROFFSET, OnAjouteroffset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// COpeCoDlg message handlers
void COpeCoDlg::OnOK() 
{
	//Supprim
	//CDialog::OnOK();
}
//________________________________________
BOOL COpeCoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur le document
  if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	short i;
	CString s;
	for (i=0;i<5;i++)
	{
		s.Format("%d",i+1);	
		m_comboCourbe.AddString(s);
	}
	m_comboCourbe.GetLBText(0,s);
	m_comboCourbe.SetWindowText(s);	
	Affiche(0);	
	return TRUE;
}
//________________________________________
void COpeCoDlg::OnAppli() 
{
	short courbe,i;
	float x,y,ymin,ymax;
	UpdateData(TRUE);
	if (m_comboCourbe.GetCurSel()>=0)
	{
		//Si on a touch au combo...
		courbe=m_comboCourbe.GetCurSel();
	}
	else
		courbe=0;
	MetAJour(courbe);
	//CString z;z.Format("%d,%d",courbe,m_OKNorme);AfxMessageBox(z);
	for (i=0;i<m_pDoc->m_iNbMax;i++)
	{
		x=m_pDoc->m_fT[i][courbe*2];
		y=m_pDoc->m_fT[i][courbe*2+1];
		if (x!=1e10 && y!=1e10)
		{
			if (m_OKInverser)
			{
				m_pDoc->m_fT[i][courbe*2+1]=-y;
			}
			if (m_OKAjouterOffset)
			{
				m_pDoc->m_fT[i][courbe*2+1]=y+m_fOffset;
			}
			if (m_OKDecaler)
			{
				m_pDoc->m_fT[i][courbe*2]=x+m_fDecAng;
			}
		}
	}
	
	if (m_OKNorme)
	{
		if (m_pDoc->m_fNorme[courbe]==1e10)
		{
			//On normalise le graphe
			ymin=1e10;ymax=-1e10;
			for (i=0;i<m_pDoc->m_iNbMax;i++)
			{
				y=m_pDoc->m_fT[i][courbe*2+1];
				if (y!=1e10)
				{
					if (y<ymin) ymin=y;
					if (y>ymax) ymax=y;
				}
			}
			if (fabs(ymax)>fabs(ymin)) m_pDoc->m_fNorme[courbe]=fabs(ymax); else m_pDoc->m_fNorme[courbe]=fabs(ymin);
			for (i=0;i<m_pDoc->m_iNbMax;i++)
			{
				if (m_pDoc->m_fT[i][courbe*2+1]!=1e10)
				{
					m_pDoc->m_fT[i][courbe*2+1]=m_pDoc->m_fT[i][courbe*2+1]/m_pDoc->m_fNorme[courbe];
				}
			}
		}
	}
	else
	{
		if (m_pDoc->m_fNorme[courbe]!=1e10)
		{
			//AfxMessageBox("ici");
			//On supprime la normalisation du graphe
			for (i=0;i<m_pDoc->m_iNbMax;i++)
			{
				if (m_pDoc->m_fT[i][courbe*2+1]!=1e10)
				{
					m_pDoc->m_fT[i][courbe*2+1]=m_pDoc->m_fT[i][courbe*2+1]*m_pDoc->m_fNorme[courbe];
				}
			}
			m_pDoc->m_fNorme[courbe]=1e10;
		}
	}
	m_pDoc->UpdateAllViews(NULL);
}
//________________________________________
void COpeCoDlg::Affiche(short NoCourbe)
{
	m_fOffset=m_pDoc->m_fOffset[NoCourbe];
	m_fDecAng=m_pDoc->m_fDecAng[NoCourbe];
	m_sIntitule=m_pDoc->m_sIntitule[NoCourbe];
	m_OKIntitule=m_pDoc->m_OKIntitule[NoCourbe];
	m_OKInverser=m_pDoc->m_OKInverser[NoCourbe];
	m_OKDecaler=m_pDoc->m_OKDecaler[NoCourbe];
	m_OKAjouterOffset=m_pDoc->m_OKAjouterOffset[NoCourbe];
	m_OKNorme=m_pDoc->m_OKNorme[NoCourbe];
	if (!m_OKAjouterOffset) GetDlgItem(IDC_OFFSET)->EnableWindow(FALSE); else GetDlgItem(IDC_OFFSET)->EnableWindow(TRUE);
	if (!m_OKDecaler) GetDlgItem(IDC_DEC_ANG)->EnableWindow(FALSE); else GetDlgItem(IDC_DEC_ANG)->EnableWindow(TRUE);
	if (!m_OKIntitule) GetDlgItem(IDC_INTITULE)->EnableWindow(FALSE); else GetDlgItem(IDC_INTITULE)->EnableWindow(TRUE);
	UpdateData(FALSE);
}
//________________________________________
void COpeCoDlg::MetAJour(short NoCourbe)
{
	UpdateData(TRUE);
	m_pDoc->m_fOffset[NoCourbe]=m_fOffset;
	m_pDoc->m_fDecAng[NoCourbe]=m_fDecAng;
	m_pDoc->m_sIntitule[NoCourbe]=m_sIntitule;
	m_pDoc->m_OKIntitule[NoCourbe]=m_OKIntitule;
	m_pDoc->m_OKInverser[NoCourbe]=m_OKInverser;
	m_pDoc->m_OKNorme[NoCourbe]=m_OKNorme;
	m_pDoc->m_OKDecaler[NoCourbe]=m_OKDecaler;
	m_pDoc->m_OKAjouterOffset[NoCourbe]=m_OKAjouterOffset;
}
//________________________________________
void COpeCoDlg::OnSelchangeComboCourbe() 
{
	short i;
	if (m_comboCourbe.GetCurSel()>=0)
	{
		//Si on a touch au combo...
		i=m_comboCourbe.GetCurSel();
	}
	else
		i=0;
	Affiche(i);
}
//________________________________________
void COpeCoDlg::OnIntitul() 
{
	m_OKIntitule=!m_OKIntitule;
	if (!m_OKIntitule) GetDlgItem(IDC_INTITULE)->EnableWindow(FALSE); else GetDlgItem(IDC_INTITULE)->EnableWindow(TRUE);
}
//________________________________________
void COpeCoDlg::OnDecaler() 
{
	m_OKDecaler=!m_OKDecaler;	
	if (!m_OKDecaler) GetDlgItem(IDC_DEC_ANG)->EnableWindow(FALSE); else GetDlgItem(IDC_DEC_ANG)->EnableWindow(TRUE);
}
//________________________________________
void COpeCoDlg::OnAjouteroffset() 
{
	m_OKAjouterOffset=!m_OKAjouterOffset;
	if (!m_OKAjouterOffset) GetDlgItem(IDC_OFFSET)->EnableWindow(FALSE); else GetDlgItem(IDC_OFFSET)->EnableWindow(TRUE);
}

